import uuid

from sqlalchemy import UUID
from sqlalchemy.orm import Mapped, mapped_column

from api.infrastructure.persistence.models.base import Base


class UserModel(Base):
    __tablename__ = "user"

    id: Mapped[uuid.UUID] = mapped_column(
        UUID(as_uuid=True),
        primary_key=True,
    )
    name: Mapped[str]
    email: Mapped[str] = mapped_column(unique=True)
    hashed_password: Mapped[str]
