from sqlalchemy import insert
from sqlalchemy.ext.asyncio import AsyncSession

from api.domain.user import User, UserRepository
from api.infrastructure.persistence.models.user import UserModel


class SqlAlchemyUserRepository(UserRepository):
    def __init__(self, session: AsyncSession) -> None:
        self.session = session

    async def create_user(self, user: User) -> None:
        stmt = insert(UserModel).values(
            id=user.id,
            name=user.name,
            email=user.email,
            hashed_password=user.password,
        )
        await self.session.execute(stmt)

    async def get_user(self, filter: dict) -> User | None:
        pass

    async def get_users(self) -> list[User]:
        return []
